/*-----------------------------------------------------------------------------
	tfilesign ŏt@C؂Tv  Copyright (c) TORO 2014
-----------------------------------------------------------------------------*/
#include <windows.h>

int VerifyZipImage(const TCHAR *SignedFileName);
#define VERIFYZIP_SUCCEDD 0
#define VERIFYZIP_FAILED 1
#define VERIFYZIP_NOSUPPORTVERIFY 2

int main(int argc,char *argv[])
{
	if ( VerifyZipImage(argv[1]) == VERIFYZIP_SUCCEDD ){
		printf( "%s is OK.",argv[1] );
	}else{
		printf( "%s is BAD.",argv[1] );
	}
	return 0;
}

// tfilesign-pubkey.dat ̒gɏ
BYTE DefaultPublicKey[] = {
 0x45,0x43,0x53,0x31,0x20,0x00,0x00,0x00,
 0x1D,0xA8,0x8F,0xA9,0xB1,0xD7,0x80,0xAD,
 0x4B,0x72,0x1E,0x76,0x60,0xD3,0x8C,0xD7,
 0xB1,0x6A,0x65,0x74,0x72,0x37,0x93,0x06,
 0x43,0x90,0x92,0x8A,0x1D,0x4A,0x76,0x9D,
 0xA8,0x09,0xAB,0x13,0x92,0x54,0xEA,0x36,
 0x3C,0x97,0x1C,0xEB,0x53,0xA9,0x7C,0xD6,
 0xFB,0x72,0x84,0x24,0xFB,0x3A,0x80,0x86,
 0x6D,0x1F,0xFF,0xC1,0xB5,0xD9,0x84,0x3F
};
#define DefaultPublicKeySize 0x48

#ifndef STATUS_SUCCESS
#define STATUS_SUCCESS ((NTSTATUS)0x00000000L)
typedef LONG NTSTATUS;
#endif

#ifndef BCRYPT_SHA1_ALGORITHM
#define BCRYPT_MD5_ALGORITHM  L"MD5"
#define BCRYPT_SHA1_ALGORITHM L"SHA1"
#define BCRYPT_ECDSA_P256_ALGORITHM L"ECDSA_P256"
#define BCRYPT_OBJECT_LENGTH L"ObjectLength"
#define BCRYPT_HASH_LENGTH L"HashDigestLength"
#define BCRYPT_ECCPUBLIC_BLOB L"ECCPUBLICBLOB"
#endif

#define UseHashAlgorithm	BCRYPT_SHA1_ALGORITHM
#define UseKeyAlgorithm		BCRYPT_ECDSA_P256_ALGORITHM

typedef PVOID BCRYPT_HANDLE;
typedef PVOID BCRYPT_ALG_HANDLE;
typedef PVOID BCRYPT_KEY_HANDLE;
typedef PVOID BCRYPT_HASH_HANDLE;

#define DefineWinAPI(retvar,name,param) typedef retvar (WINAPI *imp ## name) param; imp ## name D ## name

DefineWinAPI(NTSTATUS,BCryptOpenAlgorithmProvider,(BCRYPT_ALG_HANDLE *,LPCWSTR,LPCWSTR,ULONG));
DefineWinAPI(NTSTATUS,BCryptGetProperty,(BCRYPT_HANDLE,LPCWSTR,PUCHAR,ULONG,ULONG *,ULONG));
DefineWinAPI(NTSTATUS,BCryptCreateHash,(BCRYPT_ALG_HANDLE,BCRYPT_HASH_HANDLE *,PUCHAR,ULONG,PUCHAR,ULONG,ULONG));
DefineWinAPI(NTSTATUS,BCryptHashData,(BCRYPT_HASH_HANDLE,PUCHAR,ULONG,ULONG));
DefineWinAPI(NTSTATUS,BCryptFinishHash,(BCRYPT_HASH_HANDLE,PUCHAR,ULONG,ULONG));
DefineWinAPI(NTSTATUS,BCryptDestroyHash,(BCRYPT_HASH_HANDLE));
DefineWinAPI(NTSTATUS,BCryptCloseAlgorithmProvider,(BCRYPT_ALG_HANDLE,ULONG));
DefineWinAPI(NTSTATUS,BCryptImportKeyPair,(BCRYPT_ALG_HANDLE,BCRYPT_KEY_HANDLE,LPCWSTR,BCRYPT_KEY_HANDLE *,PUCHAR,ULONG,ULONG));
DefineWinAPI(NTSTATUS,BCryptVerifySignature,(BCRYPT_KEY_HANDLE,VOID *,PUCHAR,ULONG,PUCHAR,ULONG,ULONG));
DefineWinAPI(NTSTATUS,BCryptDestroyKey,(BCRYPT_KEY_HANDLE));

typedef struct {
	void (WINAPI **APIptr)();	// 擾APIւ̃|C^(ŏIȂ NULL)
	const char *APIname;		// 擾API̖O
} LOADWINAPISTRUCT;
#define LOADWINAPI1(name)	{(void (WINAPI **)())&(D ## name),#name}

LOADWINAPISTRUCT BCRYPTDLL[] = {
	LOADWINAPI1(BCryptOpenAlgorithmProvider),
	LOADWINAPI1(BCryptGetProperty),
	LOADWINAPI1(BCryptCreateHash),
	LOADWINAPI1(BCryptHashData),
	LOADWINAPI1(BCryptFinishHash),
	LOADWINAPI1(BCryptDestroyHash),
	LOADWINAPI1(BCryptCloseAlgorithmProvider),
	LOADWINAPI1(BCryptImportKeyPair),
	LOADWINAPI1(BCryptVerifySignature),
	LOADWINAPI1(BCryptDestroyKey),
	{NULL,NULL}
};

BOOL GetImageHash(BYTE *Image,DWORD ImageSize,BYTE **HashData,DWORD *HashSize);
HMODULE LoadWinAPI(const char *DLLname,LOADWINAPISTRUCT *apis);
DWORD LoadFileImage(const TCHAR *filename,DWORD margin,char **image,DWORD *imagesize,DWORD *filesize);

int VerifyZipImage(const TCHAR *SignedFileName)
{
	BYTE *fileimage = NULL;
	DWORD filesize;
	int success = VERIFYZIP_FAILED;

	BCRYPT_ALG_HANDLE hAlg = NULL;
	BCRYPT_KEY_HANDLE hKey = NULL;

	HANDLE hBCRYPT = LoadWinAPI("BCRYPT.DLL",BCRYPTDLL);

	if ( hBCRYPT == NULL ) return VERIFYZIP_NOSUPPORTVERIFY;

	if ( NO_ERROR != LoadFileImage(SignedFileName,0x1000,(char **)&fileimage,NULL,&filesize) ){
		FreeLibrary(hBCRYPT);
		return VERIFYZIP_NOSUPPORTVERIFY;
	}

	if ( STATUS_SUCCESS != DBCryptOpenAlgorithmProvider(&hAlg,UseKeyAlgorithm,NULL,0) ){
		success = VERIFYZIP_NOSUPPORTVERIFY;
	}

	if ( success ){
		if ( STATUS_SUCCESS != DBCryptImportKeyPair(hAlg,NULL,BCRYPT_ECCPUBLIC_BLOB,&hKey,DefaultPublicKey,DefaultPublicKeySize,0) ){
			success = VERIFYZIP_NOSUPPORTVERIFY;
		}
	}

	if ( success ) for(;;){
		DWORD DataSize;
		DWORD SignatureSize;
		DWORD HashDataSize;
		BYTE *HashData;
		BYTE *Signature;

		success = VERIFYZIP_FAILED;
		if ( filesize < (DWORD)0x100 ) break;
		SignatureSize = ((*(fileimage + filesize - 4) - 'a') << 8) + ((*(fileimage + filesize - 3) - 'a') << 4) + (*(fileimage + filesize - 2) - 'a');
		if ( SignatureSize >= 0x100 ) break;;

		DataSize = filesize - SignatureSize;
		if ( *fileimage == 'P' ) DataSize -= sizeof(WORD);
		Signature = fileimage + filesize - SignatureSize;
		SignatureSize = (SignatureSize - 3 - 1) / 2;

		{
			BYTE *src,*dest;
			DWORD size = SignatureSize;

			src = dest = Signature;
			while ( size ){
				*dest++ = (BYTE)(((*src - 'a') << 4) + (*(src + 1) - 'a'));
				src += 2;
				size--;
			}
		}

		if ( !GetImageHash(fileimage,DataSize,&HashData,&HashDataSize) ){
			break;
		}

		if ( STATUS_SUCCESS == DBCryptVerifySignature(hKey,NULL,HashData,HashDataSize,Signature,SignatureSize,0) ){
			success = VERIFYZIP_SUCCEDD;
		}
		HeapFree(GetProcessHeap(),0,HashData);
		break;
	}
	if ( hKey != NULL ) DBCryptDestroyKey(hKey);
	if ( hAlg != NULL ) DBCryptCloseAlgorithmProvider(hAlg,0);
	HeapFree(GetProcessHeap(),0,fileimage);
	FreeLibrary(hBCRYPT);
	return success;
}

BOOL GetImageHash(BYTE *Image,DWORD ImageSize,BYTE **HashData,DWORD *HashSize)
{
	BCRYPT_ALG_HANDLE hAlg;
	BCRYPT_HASH_HANDLE hHash;
	DWORD resultsize;
	DWORD worksize;
	BYTE *hashwork;

	if ( STATUS_SUCCESS != DBCryptOpenAlgorithmProvider(&hAlg,UseHashAlgorithm,NULL,0) ){
		return FALSE;
	}

	DBCryptGetProperty(hAlg,BCRYPT_OBJECT_LENGTH,(LPBYTE)&worksize,sizeof(worksize),&resultsize,0);
	hashwork = (BYTE *)HeapAlloc(GetProcessHeap(),0,worksize);
	if ( STATUS_SUCCESS != DBCryptCreateHash(hAlg,&hHash,hashwork,worksize,NULL,0,0) ){
		HeapFree(GetProcessHeap(),0,hashwork);
		DBCryptCloseAlgorithmProvider(hAlg,0);
		return FALSE;
	}
	DBCryptHashData(hHash,Image,ImageSize,0);
	DBCryptGetProperty(hAlg,BCRYPT_HASH_LENGTH,(LPBYTE)HashSize,sizeof(DWORD),&resultsize,0);
	*HashData = (LPBYTE)HeapAlloc(GetProcessHeap(),0,*HashSize);
	DBCryptFinishHash(hHash,*HashData,*HashSize,0);

	DBCryptDestroyHash(hHash);
	HeapFree(GetProcessHeap(),0,hashwork);
	DBCryptCloseAlgorithmProvider(hAlg,0);
	return TRUE;
}

HMODULE LoadWinAPI(const char *DLLname,LOADWINAPISTRUCT *apis)
{
	HMODULE hDLL;

	hDLL = LoadLibraryA(DLLname);
	if ( hDLL == NULL ) return NULL;
	while (apis->APIname != NULL){
		*apis->APIptr = (void (WINAPI *)())GetProcAddress(hDLL,apis->APIname);
		if ( *apis->APIptr == NULL ){
			FreeLibrary(hDLL);
			return NULL;
		}
		apis++;
	}
	return hDLL;
}

DWORD LoadFileImage(const TCHAR *filename,DWORD margin,char **image,DWORD *imagesize,DWORD *filesize)
{
	BOOL useheap; // q[vmۂȂ true
	HANDLE hFile;
	DWORD imgsize;
	DWORD sizeL,sizeH;		// t@C̑傫
	DWORD result;
	HWND hWnd = NULL;
										// t@CJ ---------------------
	hFile = CreateFile(filename,GENERIC_READ,
			FILE_SHARE_WRITE | FILE_SHARE_READ,NULL,
			OPEN_EXISTING,FILE_FLAG_SEQUENTIAL_SCAN,NULL);
	if ( hFile == INVALID_HANDLE_VALUE ) return GetLastError();
										// t@CTCY̊mF ---------------
	sizeL = GetFileSize(hFile,&sizeH);
	if ( (sizeL == 0xffffffff) && ((result = GetLastError()) != NO_ERROR) ){
		CloseHandle(hFile);
		return result;
	}

	if ( sizeH ) sizeL = 0xffffffff;
	if ( filesize ) *filesize = sizeL;
										// ǂݍݏ -----------------------
	if ( *image ){				// ͊mۍς
		useheap = FALSE;
		imgsize = *imagesize;
		if ( imgsize < sizeL ) sizeL = imgsize;
		if ( imgsize < (sizeL + margin) ) margin = imgsize - sizeL;
	}else{						// m
		useheap = TRUE;
		if ( (*image = HeapAlloc(GetProcessHeap(),0,sizeL + margin)) == NULL ){
			result = GetLastError();
			CloseHandle(hFile);
			return result;
		}
	}
										// ǂݍ & 0 padding ---------------
	result = ReadFile(hFile,*image,sizeL,&sizeL,NULL) ?
			NO_ERROR : GetLastError();
	CloseHandle(hFile);
	if ( result != NO_ERROR ){
		if ( useheap ) HeapFree(GetProcessHeap(),0,*image);
		return result;
	}
	if ( margin != 0 ) memset(*image + sizeL,0,margin);
	if ( imagesize != NULL ) *imagesize = sizeL;
	return NO_ERROR;
}
